Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -2271,187 +2727,252 @@
    * DataInputs and ResponseDocument / RawDataOutput
    */
-  char *dfv=addDefaultValues(&request_input_real_format,s1->inputs,m,0);
-  maps *ptr=request_input_real_format;
-  while(ptr!=NULL){
-    map *tmp0=getMap(ptr->content,"size");
-    map *tmp1=getMap(ptr->content,"maximumMegabytes");
-    if(tmp1!=NULL && tmp0!=NULL){
-      float i=atof(tmp0->value)/1048576.0;
-      if(i>=atoi(tmp1->value)){
-	char tmps[1024];
-	map* tmpe=createMap("code","FileSizeExceeded");
-	snprintf(tmps,1024,_("The <%s> parameter has a limited size (%sMB) defined in ZOO ServicesProvider configuration file but the reference you provided exceed this limitation (%fMB), please correct your query or the ZOO Configuration file."),ptr->name,tmp1->value,i);
-	addToMap(tmpe,"locator",ptr->name);
-	addToMap(tmpe,"text",tmps);
-	printExceptionReportResponse(m,tmpe);
-	freeService(&s1);
-	free(s1);
-	freeMap(&tmpe);
-	free(tmpe);
-	freeMaps(&m);
-	free(m);
-	free(REQUEST);
-	free(SERVICE_URL);
-	freeMaps(&request_input_real_format);
-	free(request_input_real_format);
-	freeMaps(&request_output_real_format);
-	free(request_output_real_format);
-	freeMaps(&tmpmaps);
-	free(tmpmaps);
-	return 1;
-      }
-    }
-    ptr=ptr->next;
-  }
-
-  char *dfv1=addDefaultValues(&request_output_real_format,s1->outputs,m,1);
-  if(strcmp(dfv1,"")!=0 || strcmp(dfv,"")!=0){
-    char tmps[1024];
-    map* tmpe=createMap("code","MissingParameterValue");
-    if(strcmp(dfv,"")!=0){
-      snprintf(tmps,1024,_("The <%s> argument was not specified in DataInputs but defined as requested in ZOO ServicesProvider configuration file, please correct your query or the ZOO Configuration file."),dfv);
-      addToMap(tmpe,"locator",dfv);
-    }
-    else if(strcmp(dfv1,"")!=0){
-      snprintf(tmps,1024,_("The <%s> argument was specified as Output identifier but not defined in the ZOO Configuration File. Please, correct your query or the ZOO Configuration File."),dfv1);
-      addToMap(tmpe,"locator",dfv1);
-    }
-    addToMap(tmpe,"text",tmps);
-    printExceptionReportResponse(m,tmpe);
-    freeService(&s1);
-    free(s1);
-    freeMap(&tmpe);
-    free(tmpe);
-    freeMaps(&m);
-    free(m);
-    free(REQUEST);
-    free(SERVICE_URL);
-    freeMaps(&request_input_real_format);
-    free(request_input_real_format);
-    freeMaps(&request_output_real_format);
-    free(request_output_real_format);
-    freeMaps(&tmpmaps);
-    free(tmpmaps);
-    return 1;
-  }
-  maps* tmpReqI=request_input_real_format;
-  while(tmpReqI!=NULL){
-    char name[1024];
-    if(getMap(tmpReqI->content,"isFile")!=NULL){
-      if (cgiFormFileName(tmpReqI->name, name, sizeof(name)) == cgiFormSuccess) {
-	int BufferLen=1024;
-	cgiFilePtr file;
-	int targetFile;
-	char storageNameOnServer[2048];
-	char fileNameOnServer[64];
-	char contentType[1024];
-	char buffer[1024];
-	char *tmpStr=NULL;
-	int size;
-	int got,t;
-	map *path=getMapFromMaps(m,"main","tmpPath");
-	cgiFormFileSize(tmpReqI->name, &size);
-	cgiFormFileContentType(tmpReqI->name, contentType, sizeof(contentType));
-	if (cgiFormFileOpen(tmpReqI->name, &file) == cgiFormSuccess) {
-	  t=-1;
-	  while(1){
-	    tmpStr=strstr(name+t+1,"\\");
-	    if(NULL==tmpStr)
-	      tmpStr=strstr(name+t+1,"/");
-	    if(NULL!=tmpStr)
-	      t=(int)(tmpStr-name);
-	    else
-	      break;
-	  }
-	  strcpy(fileNameOnServer,name+t+1);
-	  
-	  sprintf(storageNameOnServer,"%s/%s",path->value,fileNameOnServer);
-#ifdef DEBUG
-	  fprintf(stderr,"Name on server %s\n",storageNameOnServer);
-	  fprintf(stderr,"fileNameOnServer: %s\n",fileNameOnServer);
-#endif
-	  targetFile = open (storageNameOnServer,O_RDWR|O_CREAT|O_TRUNC,S_IRWXU|S_IRGRP|S_IROTH);
-	  if(targetFile<0){
-#ifdef DEBUG
-	    fprintf(stderr,"could not create the new file,%s\n",fileNameOnServer);	    
-#endif
-	  }else{
-	    while (cgiFormFileRead(file, buffer, BufferLen, &got) ==cgiFormSuccess){
-	      if(got>0)
-		write(targetFile,buffer,got);
-	    }
-	  }
-	  addToMap(tmpReqI->content,"lref",storageNameOnServer);
-	  cgiFormFileClose(file);
-	  close(targetFile);
-#ifdef DEBUG
-	  fprintf(stderr,"File \"%s\" has been uploaded",fileNameOnServer);
-#endif
-	}
-      }
-    }
-    tmpReqI=tmpReqI->next;
-  }
-
-  ensureDecodedBase64(&request_input_real_format);
-
-#ifdef DEBUG
-  fprintf(stderr,"REQUEST_INPUTS\n");
-  dumpMaps(request_input_real_format);
-  fprintf(stderr,"REQUEST_OUTPUTS\n");
-  dumpMaps(request_output_real_format);
-#endif
-
-  maps* curs=getMaps(m,"env");
-  if(curs!=NULL){
-    map* mapcs=curs->content;
-    while(mapcs!=NULLMAP){
+  char *dfv = addDefaultValues (&request_input_real_format, s1->inputs, m, 0);
+  maps *ptr = request_input_real_format;
+  while (ptr != NULL)
+    {
+      map *tmp0 = getMap (ptr->content, "size");
+      map *tmp1 = getMap (ptr->content, "maximumMegabytes");
+      if (tmp1 != NULL && tmp0 != NULL)
+        {
+          float i = atof (tmp0->value) / 1048576.0;
+          if (i >= atoi (tmp1->value))
+            {
+              char tmps[1024];
+              map *tmpe = createMap ("code", "FileSizeExceeded");
+              snprintf (tmps, 1024,
+                        _
+                        ("The <%s> parameter has a limited size (%sMB) defined in ZOO ServicesProvider configuration file but the reference you provided exceed this limitation (%fMB), please correct your query or the ZOO Configuration file."),
+                        ptr->name, tmp1->value, i);
+              addToMap (tmpe, "locator", ptr->name);
+              addToMap (tmpe, "text", tmps);
+              printExceptionReportResponse (m, tmpe);
+              freeService (&s1);
+              free (s1);
+              freeMap (&tmpe);
+              free (tmpe);
+              freeMaps (&m);
+              free (m);
+              free (REQUEST);
+              free (SERVICE_URL);
+              freeMaps (&request_input_real_format);
+              free (request_input_real_format);
+              freeMaps (&request_output_real_format);
+              free (request_output_real_format);
+              freeMaps (&tmpmaps);
+              free (tmpmaps);
+              return 1;
+            }
+        }
+      ptr = ptr->next;
+    }
+
+  char *dfv1 =
+    addDefaultValues (&request_output_real_format, s1->outputs, m, 1);
+  if (strcmp (dfv1, "") != 0 || strcmp (dfv, "") != 0)
+    {
+      char tmps[1024];
+      map *tmpe = createMap ("code", "MissingParameterValue");
+      if (strcmp (dfv, "") != 0)
+        {
+          snprintf (tmps, 1024,
+                    _
+                    ("The <%s> argument was not specified in DataInputs but defined as requested in ZOO ServicesProvider configuration file, please correct your query or the ZOO Configuration file."),
+                    dfv);
+          addToMap (tmpe, "locator", dfv);
+        }
+      else if (strcmp (dfv1, "") != 0)
+        {
+          snprintf (tmps, 1024,
+                    _
+                    ("The <%s> argument was specified as Output identifier but not defined in the ZOO Configuration File. Please, correct your query or the ZOO Configuration File."),
+                    dfv1);
+          addToMap (tmpe, "locator", dfv1);
+        }
+      addToMap (tmpe, "text", tmps);
+      printExceptionReportResponse (m, tmpe);
+      freeService (&s1);
+      free (s1);
+      freeMap (&tmpe);
+      free (tmpe);
+      freeMaps (&m);
+      free (m);
+      free (REQUEST);
+      free (SERVICE_URL);
+      freeMaps (&request_input_real_format);
+      free (request_input_real_format);
+      freeMaps (&request_output_real_format);
+      free (request_output_real_format);
+      freeMaps (&tmpmaps);
+      free (tmpmaps);
+      return 1;
+    }
+  maps *tmpReqI = request_input_real_format;
+  while (tmpReqI != NULL)
+    {
+      char name[1024];
+      if (getMap (tmpReqI->content, "isFile") != NULL)
+        {
+          if (cgiFormFileName (tmpReqI->name, name, sizeof (name)) ==
+              cgiFormSuccess)
+            {
+              int BufferLen = 1024;
+              cgiFilePtr file;
+              int targetFile;
+              char storageNameOnServer[2048];
+              char fileNameOnServer[64];
+              char contentType[1024];
+              char buffer[1024];
+              char *tmpStr = NULL;
+              int size;
+              int got, t;
+              map *path = getMapFromMaps (m, "main", "tmpPath");
+              cgiFormFileSize (tmpReqI->name, &size);
+              cgiFormFileContentType (tmpReqI->name, contentType,
+                                      sizeof (contentType));
+              if (cgiFormFileOpen (tmpReqI->name, &file) == cgiFormSuccess)
+                {
+                  t = -1;
+                  while (1)
+                    {
+                      tmpStr = strstr (name + t + 1, "\\");
+                      if (NULL == tmpStr)
+                        tmpStr = strstr (name + t + 1, "/");
+                      if (NULL != tmpStr)
+                        t = (int) (tmpStr - name);
+                      else
+                        break;
+                    }
+                  strcpy (fileNameOnServer, name + t + 1);
+
+                  sprintf (storageNameOnServer, "%s/%s", path->value,
+                           fileNameOnServer);
+#ifdef DEBUG
+                  fprintf (stderr, "Name on server %s\n",
+                           storageNameOnServer);
+                  fprintf (stderr, "fileNameOnServer: %s\n",
+                           fileNameOnServer);
+#endif
+                  targetFile =
+                    open (storageNameOnServer, O_RDWR | O_CREAT | O_TRUNC,
+                          S_IRWXU | S_IRGRP | S_IROTH);
+                  if (targetFile < 0)
+                    {
+#ifdef DEBUG
+                      fprintf (stderr, "could not create the new file,%s\n",
+                               fileNameOnServer);
+#endif
+                    }
+                  else
+                    {
+                      while (cgiFormFileRead (file, buffer, BufferLen, &got)
+                             == cgiFormSuccess)
+                        {
+                          if (got > 0)
+                            write (targetFile, buffer, got);
+                        }
+                    }
+                  addToMap (tmpReqI->content, "lref", storageNameOnServer);
+                  cgiFormFileClose (file);
+                  close (targetFile);
+#ifdef DEBUG
+                  fprintf (stderr, "File \"%s\" has been uploaded",
+                           fileNameOnServer);
+#endif
+                }
+            }
+        }
+      tmpReqI = tmpReqI->next;
+    }
+
+  ensureDecodedBase64 (&request_input_real_format);
+
+#ifdef DEBUG
+  fprintf (stderr, "REQUEST_INPUTS\n");
+  dumpMaps (request_input_real_format);
+  fprintf (stderr, "REQUEST_OUTPUTS\n");
+  dumpMaps (request_output_real_format);
+#endif
+
+  maps *curs = getMaps (m, "env");
+  if (curs != NULL)
+    {
+      map *mapcs = curs->content;
+      while (mapcs != NULLMAP)
+        {
 #ifndef WIN32
-      setenv(mapcs->name,mapcs->value,1);
+          setenv (mapcs->name, mapcs->value, 1);
 #else
 #ifdef DEBUG
-      fprintf(stderr,"[ZOO: setenv (%s=%s)]\n",mapcs->name,mapcs->value);
-#endif
-      if(mapcs->value[strlen(mapcs->value)-2]=='\r'){
-#ifdef DEBUG
-	fprintf(stderr,"[ZOO: Env var finish with \r]\n");
-#endif
-	mapcs->value[strlen(mapcs->value)-1]=0;
-      }
-#ifdef DEBUG
-      fflush(stderr);
-      fprintf(stderr,"setting variable... %s\n",(
-#endif
-						 SetEnvironmentVariable(mapcs->name,mapcs->value)
-#ifdef DEBUG
-						 ==0)? "OK" : "FAILED");
+          fprintf (stderr, "[ZOO: setenv (%s=%s)]\n", mapcs->name,
+                   mapcs->value);
+#endif
+          if (mapcs->value[strlen (mapcs->value) - 2] == '\r')
+            {
+#ifdef DEBUG
+              fprintf (stderr, "[ZOO: Env var finish with \r]\n");
+#endif
+              mapcs->value[strlen (mapcs->value) - 1] = 0;
+            }
+#ifdef DEBUG
+          fflush (stderr);
+          fprintf (stderr, "setting variable... %s\n", (
+#endif
+                                                         SetEnvironmentVariable
+                                                         (mapcs->name,
+                                                          mapcs->value)
+#ifdef DEBUG
+                                                         == 0) ? "OK" :
+                   "FAILED");
 #else
-      ;
-#endif
-      char* toto=(char*)malloc((strlen(mapcs->name)+strlen(mapcs->value)+2)*sizeof(char));
-      sprintf(toto,"%s=%s",mapcs->name,mapcs->value);
-      putenv(toto);
-#ifdef DEBUG
-      fflush(stderr);
-#endif
-#endif
-#ifdef DEBUG
-      fprintf(stderr,"[ZOO: setenv (%s=%s)]\n",mapcs->name,mapcs->value);
-      fflush(stderr);
-#endif
-      mapcs=mapcs->next;
-    }
-  }
-  
-#ifdef DEBUG
-  dumpMap(request_inputs);
-#endif
-
+                                                         ;
+#endif
+                                                         char *toto =
+                                                         (char
+                                                          *)malloc ((strlen
+                                                                     (mapcs->
+                                                                      name) +
+                                                                     strlen
+                                                                     (mapcs->
+                                                                      value) +
+                                                                     2) *
+                                                                    sizeof
+                                                                    (char));
+                                                         sprintf (toto,
+                                                                  "%s=%s",
+                                                                  mapcs->name,
+                                                                  mapcs->
+                                                                  value);
+                                                         putenv (toto);
+#ifdef DEBUG
+                                                         fflush (stderr);
+#endif
+#endif
+#ifdef DEBUG
+                                                         fprintf (stderr,
+                                                                  "[ZOO: setenv (%s=%s)]\n",
+                                                                  mapcs->name,
+                                                                  mapcs->
+                                                                  value);
+                                                         fflush (stderr);
+#endif
+                                                         mapcs = mapcs->next;}
+                                                         }
+
+#ifdef DEBUG
+                                                         dumpMap
+                                                         (request_inputs);
+#endif
   /**
    * Need to check if we need to fork to load a status enabled 
    */
-  r_inputs=NULL;
-  map* store=getMap(request_inputs,"storeExecuteResponse");
-  map* status=getMap(request_inputs,"status");
+                                                         r_inputs = NULL;
+                                                         map * store =
+                                                         getMap
+                                                         (request_inputs,
+                                                          "storeExecuteResponse");
+                                                         map * status =
+                                                         getMap
+                                                         (request_inputs,
+                                                          "status");
   /**
    * 05-007r7 WPS 1.0.0 page 57 :
@@ -2459,26 +2980,42 @@
    * shall raise an exception.'
    */
-  if(status!=NULL && strcmp(status->value,"true")==0 && 
-     store!=NULL && strcmp(store->value,"false")==0){
-    errorException(m, _("Status cannot be set to true with storeExecuteResponse to false. Please, modify your request parameters."), "InvalidParameterValue","storeExecuteResponse");
-    freeService(&s1);
-    free(s1);
-    freeMaps(&m);
-    free(m);
-    
-    freeMaps(&request_input_real_format);
-    free(request_input_real_format);
-    
-    freeMaps(&request_output_real_format);
-    free(request_output_real_format);
-    
-    free(REQUEST);
-    free(SERVICE_URL);
-    return 1;
-  }
-  r_inputs=getMap(request_inputs,"storeExecuteResponse");
-  int eres=SERVICE_STARTED;
-  int cpid=getpid();
-
+                                                         if (status != NULL
+                                                             &&
+                                                             strcmp
+                                                             (status->value,
+                                                              "true") == 0
+                                                             && store != NULL
+                                                             &&
+                                                             strcmp
+                                                             (store->value,
+                                                              "false") == 0)
+                                                         {
+                                                         errorException (m,
+                                                                         _
+                                                                         ("Status cannot be set to true with storeExecuteResponse to false. Please, modify your request parameters."),
+                                                                         "InvalidParameterValue",
+                                                                         "storeExecuteResponse");
+                                                         freeService (&s1);
+                                                         free (s1);
+                                                         freeMaps (&m);
+                                                         free (m);
+                                                         freeMaps
+                                                         (&request_input_real_format);
+                                                         free
+                                                         (request_input_real_format);
+                                                         freeMaps
+                                                         (&request_output_real_format);
+                                                         free
+                                                         (request_output_real_format);
+                                                         free (REQUEST);
+                                                         free (SERVICE_URL);
+                                                         return 1;}
+                                                         r_inputs =
+                                                         getMap
+                                                         (request_inputs,
+                                                          "storeExecuteResponse");
+                                                         int eres =
+                                                         SERVICE_STARTED;
+                                                         int cpid = getpid ();
   /**
    * Initialize the specific [lenv] section which contains runtime variables:
